// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/GeneralizedLanePosition.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'lane_position_based'
#include "etsi_its_denm_ts_msgs/msg/detail/lane_position_options__struct.h"
// Member 'map_based'
#include "etsi_its_denm_ts_msgs/msg/detail/map_position__struct.h"
// Member 'confidence'
#include "etsi_its_denm_ts_msgs/msg/detail/meta_information__struct.h"

/// Struct defined in msg/GeneralizedLanePosition in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__GeneralizedLanePosition
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents the top-level DF to represent a lane position. A lane position is a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway.
  ///  *
  ///  * @note: This DF is the most general way to represent a lane position: it provides a complete set of information regarding a transversal (dimensionless) position on the carriageway at a specific
  ///  * reference position, i.e. it provides different options and synonyms to represent the lane at which the reference position (the point) is located. A confidence is used to describe the probability
  ///  * that the object is located in the provided lane. The dimension of the object or extension of an area are not considered: See @ref OccupiedLanesWithConfidence for describing the occupation of lanes,
  ///  * where the dimensions of an object or the extension of an area is considered.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field lanePositionBased: lane position information for a defined reference position.
  ///  *
  ///  * @field mapBased: optional lane position information described in the context of a MAPEM as specified in ETSI TS 103 301.
  ///  * If present, it shall describe the same reference position using the lane identification in the MAPEM. This component can be used only if a MAPEM is available for the reference position
  ///  * (e.g. on an intersection): In this case it is used as a synonym to the mandatory component lanePositionBased.
  ///  *
  ///  * @field confidence: confidence information for expressing the probability that the object is located at the indicated lane.
  ///  * If the value of the component lanePositionBased is generated directly from the absolute reference position and reference topology information,
  ///  * no sensor shall be indicated in the component usedDetectionInformation of the @ref MetaInformation.
  ///  *
  ///  * @category: Road Topology information
  ///  * @revision: newly created in V2.2.1. The previous DF GeneralizedLanePosition is now renamed to @ref LanePositionOptions.
  ///  */
  /// GeneralizedLanePosition ::= SEQUENCE {
  ///     lanePositionBased     LanePositionOptions,
  ///     mapBased              MapPosition OPTIONAL,
  ///     confidence            MetaInformation,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__LanePositionOptions lane_position_based;
  etsi_its_denm_ts_msgs__msg__MapPosition map_based;
  bool map_based_is_present;
  etsi_its_denm_ts_msgs__msg__MetaInformation confidence;
} etsi_its_denm_ts_msgs__msg__GeneralizedLanePosition;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__GeneralizedLanePosition.
typedef struct etsi_its_denm_ts_msgs__msg__GeneralizedLanePosition__Sequence
{
  etsi_its_denm_ts_msgs__msg__GeneralizedLanePosition * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__GeneralizedLanePosition__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__GENERALIZED_LANE_POSITION__STRUCT_H_
