// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/LocationContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LOCATION_CONTAINER__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LOCATION_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'event_speed'
#include "etsi_its_denm_ts_msgs/msg/detail/speed__struct.h"
// Member 'event_position_heading'
#include "etsi_its_denm_ts_msgs/msg/detail/wgs84_angle__struct.h"
// Member 'detection_zones_to_event_position'
#include "etsi_its_denm_ts_msgs/msg/detail/traces__struct.h"
// Member 'road_type'
#include "etsi_its_denm_ts_msgs/msg/detail/road_type__struct.h"
// Member 'lane_positions'
#include "etsi_its_denm_ts_msgs/msg/detail/generalized_lane_positions__struct.h"
// Member 'occupied_lanes'
#include "etsi_its_denm_ts_msgs/msg/detail/occupied_lanes_with_confidence__struct.h"
// Member 'linked_ivims'
#include "etsi_its_denm_ts_msgs/msg/detail/ivim_references__struct.h"
// Member 'linked_mapems'
#include "etsi_its_denm_ts_msgs/msg/detail/map_references__struct.h"
// Member 'detection_zones_to_specified_event_point'
#include "etsi_its_denm_ts_msgs/msg/detail/traces_extended__struct.h"
// Member 'predicted_paths'
#include "etsi_its_denm_ts_msgs/msg/detail/path_predicted_list__struct.h"

/// Struct defined in msg/LocationContainer in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__LocationContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This type represents the Location Container.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field eventSpeed: optional speed of a detected dynamic event and the confidence of the speed information.
  ///  *
  ///  * @field eventPositionHeading: the optional heading of a dynamic event and the confidence of the heading information.
  ///  *
  ///  * @field detectionZonesToEventPosition: the detection zone information approaching the event position, see clause 6.1.3.3.
  ///  *
  ///  * @field roadType: the optional road type information at the event position.
  ///  *
  ///  * @field lanePositions: the optional lane(s) where the event is located, at the position indicated by the component eventPosition
  ///  * of the Management container and for a given reference direction.
  ///  *
  ///  * @field occupiedLanes: the optional lane(s) that are fully or partially occupied by the event, at the position indicated by the
  ///  * component eventPosition of the Management container and for a given reference direction.
  ///  *
  ///  * @field linkedIvims: the optional list of DF IvimReference, pointing to IVIMs that are semantically connected because providing information
  ///  * applying to the road segment(s) covered by the components detectionZonesToEventPosition, detectionZonesToSpecifiedEventPoint and
  ///  * the SituationContainer component eventZone.
  ///  *
  ///  * @field linkedMapem: the optional list of DF Mapreference, pointing to MAPEMs that are semantically connected because providing information
  ///  * applying to the road segment(s) covered by the component detectionZonesToEventPosition, detectionZonesToSpecifiedEventPoint and
  ///  * the SituationContainer component eventZone.
  ///  *
  ///  * @field detectionZonesToSpecifiedEventPoint: the optional detection zone information approaching towards a
  ///  * specified event point, see clause 6.1.3.3.
  ///  *
  ///  * @field predictedPaths: the optional list of future paths or trajectories that the event may move along or zones that the event may occupy.
  ///  *
  /// */
  /// LocationContainer ::= SEQUENCE {
  ///     eventSpeed                            Speed OPTIONAL,
  ///     eventPositionHeading                  Wgs84Angle OPTIONAL,
  ///     detectionZonesToEventPosition         Traces,
  ///     roadType                              RoadType OPTIONAL,
  ///     ...,
  /// [[ lanePositions                         GeneralizedLanePositions OPTIONAL,
  ///     occupiedLanes                         OccupiedLanesWithConfidence OPTIONAL,
  ///     linkedIvims                           IvimReferences OPTIONAL,
  ///     linkedMapems                          MapReferences OPTIONAL,
  ///     detectionZonesToSpecifiedEventPoint   TracesExtended OPTIONAL,
  ///     predictedPaths                      PathPredictedList OPTIONAL ]]
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__Speed event_speed;
  bool event_speed_is_present;
  etsi_its_denm_ts_msgs__msg__Wgs84Angle event_position_heading;
  bool event_position_heading_is_present;
  etsi_its_denm_ts_msgs__msg__Traces detection_zones_to_event_position;
  etsi_its_denm_ts_msgs__msg__RoadType road_type;
  bool road_type_is_present;
  etsi_its_denm_ts_msgs__msg__GeneralizedLanePositions lane_positions;
  bool lane_positions_is_present;
  etsi_its_denm_ts_msgs__msg__OccupiedLanesWithConfidence occupied_lanes;
  bool occupied_lanes_is_present;
  etsi_its_denm_ts_msgs__msg__IvimReferences linked_ivims;
  bool linked_ivims_is_present;
  etsi_its_denm_ts_msgs__msg__MapReferences linked_mapems;
  bool linked_mapems_is_present;
  etsi_its_denm_ts_msgs__msg__TracesExtended detection_zones_to_specified_event_point;
  bool detection_zones_to_specified_event_point_is_present;
  etsi_its_denm_ts_msgs__msg__PathPredictedList predicted_paths;
  bool predicted_paths_is_present;
} etsi_its_denm_ts_msgs__msg__LocationContainer;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__LocationContainer.
typedef struct etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence
{
  etsi_its_denm_ts_msgs__msg__LocationContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__LocationContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__LOCATION_CONTAINER__STRUCT_H_
