// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/ManagementContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'VALIDITY_DURATION_DEFAULT'.
enum
{
  etsi_its_denm_ts_msgs__msg__ManagementContainer__VALIDITY_DURATION_DEFAULT = 600
};

// Include directives for member types
// Member 'action_id'
#include "etsi_its_denm_ts_msgs/msg/detail/action_id__struct.h"
// Member 'detection_time'
// Member 'reference_time'
#include "etsi_its_denm_ts_msgs/msg/detail/timestamp_its__struct.h"
// Member 'termination'
#include "etsi_its_denm_ts_msgs/msg/detail/termination__struct.h"
// Member 'event_position'
#include "etsi_its_denm_ts_msgs/msg/detail/reference_position__struct.h"
// Member 'awareness_distance'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length3b__struct.h"
// Member 'traffic_direction'
#include "etsi_its_denm_ts_msgs/msg/detail/traffic_direction__struct.h"
// Member 'validity_duration'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_second__struct.h"
// Member 'transmission_interval'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_milli_second_positive__struct.h"
// Member 'station_type'
#include "etsi_its_denm_ts_msgs/msg/detail/station_type__struct.h"

/// Struct defined in msg/ManagementContainer in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__ManagementContainer
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This type represents the Management Container.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field actionId: the identifier of the DENM.
  ///  *
  ///  * @field detectionTime: the time at which the event is detected.
  ///  *
  ///  * @field referenceTime: the time at which a new DENM, an update DENM or a cancellation DENM is generated
  ///  *
  ///  * @field termination: the optional termination type of the DENM.
  ///  *
  ///  * @field eventPosition: the geographical position used in the definition of the awareness area / relevance zone, see clause 6.1.3.
  ///  *
  ///  * @field awarenessDistance: the optional radius of the circular awareness area, with centre at the event position or at any of the
  ///  * event history points as defined in clause 6.1.3.1.
  ///  *
  ///  * @field trafficDirection: the optional traffic direction along which the receiving ITS-S may encounter the event,
  ///  * as defined in clause 6.1.3.
  ///  *
  ///  * @field validityDuration: the validity duration of a DENM. This component represents a time offset in the unit of second since detectionTime.
  ///  *
  ///  * @field transmissionInterval: the optional time interval for DENM transmission as defined by the originating ITS-S.
  ///  * If the component is not present in DENM, a default value defaultValidity is assumed.
  ///  *
  ///  * @field stationType: the station type information of the originating ITS-S.
  ///  *
  /// */
  /// ManagementContainer ::= SEQUENCE {
  ///     actionId                  ActionId,
  ///     detectionTime             TimestampIts,
  ///     referenceTime             TimestampIts,
  ///     termination               Termination OPTIONAL,
  ///     eventPosition             ReferencePosition,
  ///     awarenessDistance         StandardLength3b OPTIONAL,
  ///     trafficDirection          TrafficDirection OPTIONAL,
  ///     validityDuration          DeltaTimeSecond DEFAULT defaultValidity,
  ///     transmissionInterval      DeltaTimeMilliSecondPositive OPTIONAL,
  ///     stationType               StationType,
  ///     ...
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__ActionId action_id;
  etsi_its_denm_ts_msgs__msg__TimestampIts detection_time;
  etsi_its_denm_ts_msgs__msg__TimestampIts reference_time;
  etsi_its_denm_ts_msgs__msg__Termination termination;
  bool termination_is_present;
  etsi_its_denm_ts_msgs__msg__ReferencePosition event_position;
  etsi_its_denm_ts_msgs__msg__StandardLength3b awareness_distance;
  bool awareness_distance_is_present;
  etsi_its_denm_ts_msgs__msg__TrafficDirection traffic_direction;
  bool traffic_direction_is_present;
  etsi_its_denm_ts_msgs__msg__DeltaTimeSecond validity_duration;
  etsi_its_denm_ts_msgs__msg__DeltaTimeMilliSecondPositive transmission_interval;
  bool transmission_interval_is_present;
  etsi_its_denm_ts_msgs__msg__StationType station_type;
} etsi_its_denm_ts_msgs__msg__ManagementContainer;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__ManagementContainer.
typedef struct etsi_its_denm_ts_msgs__msg__ManagementContainer__Sequence
{
  etsi_its_denm_ts_msgs__msg__ManagementContainer * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__ManagementContainer__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_H_
