// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/RadialShapes.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPES__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPES__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'ref_point_id'
#include "etsi_its_denm_ts_msgs/msg/detail/identifier1_b__struct.h"
// Member 'x_coordinate'
// Member 'y_coordinate'
// Member 'z_coordinate'
#include "etsi_its_denm_ts_msgs/msg/detail/cartesian_coordinate_small__struct.h"
// Member 'radial_shapes_list'
#include "etsi_its_denm_ts_msgs/msg/detail/radial_shapes_list__struct.h"

/// Struct defined in msg/RadialShapes in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__RadialShapes
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF describes a list of radial shapes positioned w.r.t. to an offset position defined
  ///  * relative to a reference position specified outside of the context of this DF and oriented w.r.t.
  ///  * a cartesian coordinate system specified outside of the context of this DF.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field refPointId: the identification of the reference point in case of a sensor mounted to trailer. Defaults to ITS ReferencePoint (0).
  ///  *
  ///  * @field xCoordinate: the x-coordinate of the offset position.
  ///  *
  ///  * @field yCoordinate: the y-coordinate of the offset position.
  ///  *
  ///  * @field zCoordinate: the optional z-coordinate of the offset position.
  ///  *
  ///  * @field radialShapesList: the list of radial shape details.
  ///  *
  ///  * @category: Georeference information
  ///  * @revision: created in V2.1.1, description revised in V2.2.1
  ///  */
  /// RadialShapes ::= SEQUENCE {
  ///     refPointId          Identifier1B,
  ///     xCoordinate         CartesianCoordinateSmall,
  ///     yCoordinate         CartesianCoordinateSmall,
  ///     zCoordinate         CartesianCoordinateSmall OPTIONAL,
  ///     radialShapesList    RadialShapesList
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__Identifier1B ref_point_id;
  etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall x_coordinate;
  etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall y_coordinate;
  etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall z_coordinate;
  bool z_coordinate_is_present;
  etsi_its_denm_ts_msgs__msg__RadialShapesList radial_shapes_list;
} etsi_its_denm_ts_msgs__msg__RadialShapes;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__RadialShapes.
typedef struct etsi_its_denm_ts_msgs__msg__RadialShapes__Sequence
{
  etsi_its_denm_ts_msgs__msg__RadialShapes * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__RadialShapes__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__RADIAL_SHAPES__STRUCT_H_
